<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;
$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();


if ( !isset($postdata['homework_id']) or !checkIfIssetAndNotEmpty($postdata['homework_id']) or
 
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;
$class_id = $jwt_validate->data->class;
$section_id = $jwt_validate->data->section;

$specific_db_name = validateStudentAcess($conn_rjllearning, $role, $workspace_id, ["student"], null, null, $userid);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
validateStudentClassSection($conn_rjllearning_specific, $userid, $institution_id, $branch_id, $class_id, $section_id);



function getStudentSpecificHomework($conn_rjllearning_specific,$institution_id,$homework_id) {
    
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM  homework where id = ? and institution_id =? ");
    $sql->execute(array($homework_id,$institution_id));
    $rows = $sql->fetchAll();
   
    if (count($rows) == 1) {
         if ($rows[0]['attachment'] != null and !is_array($rows[0]['attachment'])) {
            $data_attachment = json_decode($rows[0]['attachment'], true);
            $filePath = $data_attachment['filepath'];
            $originalName = $data_attachment['original_name'];
            $aws_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
            $final_array_attachment   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        } else {
            $final_array_attachment =  null;
        }
        
        
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows[0]['class_id']);
        $subject_info = getSubject($conn_rjllearning_specific, $institution_id, $rows[0]['subject_id']);

        $section_id = $rows[0]['section_id'];

        
          $section_info =[]; 

     if ($section_id == 'all') {
        $section_info[] = array('section_id' => $section_id, 'section_name' => ucwords($section_id));
    
        } else {
        if (is_string($section_id)) {
            $section_id = json_decode($section_id, true); // Decode if it's a JSON string
       }
    if (!is_array($section_id)) {
        $section_id = [$section_id]; // Ensure it's an array
    }
    $placeholders = implode(',', array_fill(0, count($section_id), '?'));
    $sql = "SELECT * FROM section_info WHERE institution_id = ? AND id IN ($placeholders)";
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute(array_merge([$institution_id], $section_id));
    $section_rows = $stmt->fetchAll();
    foreach ($section_rows as $section_data) {
        $section_info[] = array('section_id' => $section_data['id'], 'section_name' => $section_data['section_name']);
    }
}
        
        $branch_info  = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows[0]['branch_id']);
        return array('homework_id'=> $rows[0]['id'],'branch_id'=>$branch_info ,'class_info'=> $class_info,'subject_info'=>$subject_info,'section_info'=> $section_info,'message'=> $rows[0]['message'],'attachment'=> $final_array_attachment, 'priority' => $rows[0]['priority'],'date_created'=>$rows[0]['date_created']);
      
    }else{
          errorreturn("Enter Invalid homework info.");
    }

}

if($postdata['function_type']  == "fetch_specific_homework") {  
    
    $homework_id = trim($postdata['homework_id']);

    
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific,$institution_id);
    if($check_academic_confirmation != true){
         errorreturn("Access denied. Academic session not active.");
    }
    $success['data'] = getStudentSpecificHomework($conn_rjllearning_specific,$institution_id,$homework_id);
    successreturn($success);
      
}

